<!--
    Input:
        vendor/qcom/opensource/core-utils/vendor_framework_compatibility_matrix.xml
-->
<compatibility-matrix version="8.0" type="framework">
    <hal format="aidl" optional="true">
        <name>android.hardware.authsecret.qti.spu</name>
        <interface>
            <name>IAuthSecret</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.automotive.evs</name>
        <version>1.1</version>
        <interface>
            <name>IEvsEnumerator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.gnss</name>
        <version>1.0-1</version>
        <version>2.0-1</version>
        <interface>
            <name>IGnss</name>
            <instance>default</instance>
            <instance>gnss_vendor</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.graphics.allocator</name>
        <interface>
            <name>IAllocator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.media.c2</name>
        <version>1.0</version>
        <version>1.1</version>
        <version>1.2</version>
        <interface>
            <name>IComponentStore</name>
            <instance>default</instance>
            <instance>software</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.media.c2</name>
        <interface>
            <name>IComponentStore</name>
            <instance>default</instance>
            <instance>software</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.nfc</name>
        <version>1.0</version>
        <interface>
            <name>INfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.nfc</name>
        <interface>
            <name>INfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio</name>
        <version>1.0-4</version>
        <interface>
            <name>IRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
        <interface>
            <name>ISap</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio.config</name>
        <version>1.0-1</version>
        <interface>
            <name>IRadioConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.hardware.tetheroffload</name>
        <interface>
            <name>IOffload</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.wifi.supplicant</name>
        <version>1.0-2</version>
        <interface>
            <name>ISupplicant</name>
            <instance>default</instance>
            <instance>wigigp2p</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>android.se.omapi</name>
        <interface>
            <name>ISecureElementService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.dsi.ant</name>
        <version>1.0</version>
        <interface>
            <name>IAnt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.dpm.api</name>
        <version>1.0</version>
        <interface>
            <name>IdpmQmi</name>
            <instance>dpmQmiService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.imscmservice</name>
        <version>2.0-2</version>
        <interface>
            <name>IImsCmService</name>
            <instance>qti.ims.connectionmanagerservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.uceservice</name>
        <version>2.0-1</version>
        <version>2.2</version>
        <version>2.3</version>
        <interface>
            <name>IUceService</name>
            <instance>com.qualcomm.qti.uceservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.quicinc.cne.api</name>
        <version>1.0-1</version>
        <interface>
            <name>IApiService</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.quicinc.cne.server</name>
        <version>2.0-2</version>
        <interface>
            <name>IServer</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.aks.gamepad</name>
        <version>1.0</version>
        <interface>
            <name>IGamepad</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.color</name>
        <version>1.0-7</version>
        <interface>
            <name>IDisplayColor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.config</name>
        <version>1.0-15</version>
        <version>2.0</version>
        <interface>
            <name>IDisplayConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.postproc</name>
        <version>1.0</version>
        <interface>
            <name>IDisplayPostproc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.dolby.dvs</name>
        <version>1.0</version>
        <interface>
            <name>IDvs</name>
            <instance>dvs-hal-service</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.dolby.dvs</name>
        <interface>
            <name>IDvs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.activity_recognition</name>
        <interface>
            <name>IActivityRecognition</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.airenderlaunch</name>
        <interface>
            <name>IAiRenderLaunch</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.aiservice</name>
        <interface>
            <name>IAiService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.aoservice</name>
        <interface>
            <name>IAOService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.audioremote</name>
        <interface>
            <name>IAudioRemoteConnect</name>
            <instance>default</instance>
            <instance>virtualmodem</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.biometrics.fingerprint</name>
        <interface>
            <name>IFingerprint</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.biometrics.hwfacerecognize</name>
        <interface>
            <name>IBiometricsFaceRecognize</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.camera.camResource</name>
        <interface>
            <name>IHwCameraResourceService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.camera.cfgsvr</name>
        <interface>
            <name>IHwCamCfgSvr</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.camera.factory</name>
        <interface>
            <name>ICameraFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.camera.hiaon</name>
        <version>2</version>
        <interface>
            <name>IHIAONService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.camera.vircamera</name>
        <interface>
            <name>IVirCameraChannel</name>
            <instance>virtualcamera.register</instance>
            <instance>virtualcamera.streamchange</instance>
        </interface>
        <interface>
            <name>IVirCameraTranslator</name>
            <instance>virtualcamera.translator</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.fusd</name>
        <version>1-2</version>
        <interface>
            <name>IFusdLbs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hnblesensorhub</name>
        <version>1-2</version>
        <interface>
            <name>IHnBleSensorHub</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hncamera</name>
        <version>2</version>
        <interface>
            <name>ISarService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hnchipsrvhertz</name>
        <interface>
            <name>IHnChipSrvHertz</name>
            <instance>hnchipsrv_hertz</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hnchipsrvlog</name>
        <version>1-3</version>
        <interface>
            <name>IHnChipSrvLog</name>
            <instance>hnchipsrv_log</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hnchipsrvsat</name>
        <version>1-2</version>
        <interface>
            <name>IHnChipSrvSat</name>
            <instance>hnchipsrv_sat</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hnradio</name>
        <version>2</version>
        <interface>
            <name>IRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hnsimradio</name>
        <interface>
            <name>IHnsimradio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.honorantitheft</name>
        <interface>
            <name>IHonorAntiTheft</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.honorsigntool</name>
        <interface>
            <name>ISignTool</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwdisplay</name>
        <interface>
            <name>IDisplay</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwdisplay.displayengine</name>
        <interface>
            <name>IDisplayEngineWrapper</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwdisplay.displayfactory</name>
        <interface>
            <name>IDisplayFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwfactoryinterface</name>
        <interface>
            <name>IHwFactoryInterface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwfs</name>
        <interface>
            <name>IHwfs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwhiview</name>
        <version>2</version>
        <interface>
            <name>IHwHiviewInterface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwsched</name>
        <interface>
            <name>ISchedAidlInterface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwstp</name>
        <interface>
            <name>IHwStp</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hwupdate</name>
        <interface>
            <name>IUpdateAidlInterface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.hyperhold</name>
        <interface>
            <name>IPersistingData</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.iawareperf</name>
        <interface>
            <name>IUniPerfAidlInterface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.iawareperfpolicy</name>
        <interface>
            <name>IPerfPolicyAidlInterface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.isf</name>
        <interface>
            <name>IISF</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.kds</name>
        <interface>
            <name>IKds</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.libteec</name>
        <interface>
            <name>ILibteecGlobal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.light</name>
        <interface>
            <name>ILight</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.mdlogservice</name>
        <interface>
            <name>IMdLogService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.motion</name>
        <interface>
            <name>IMotion</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.nfc</name>
        <interface>
            <name>IHnNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.nxpnfc</name>
        <interface>
            <name>INxpNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.offlinealgo</name>
        <interface>
            <name>IOfflineAlgo</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.power</name>
        <interface>
            <name>IHWPower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.radio_radar</name>
        <version>2</version>
        <interface>
            <name>IRadioRadar</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.radioenhance</name>
        <interface>
            <name>IRadioenhance</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.remotesim</name>
        <interface>
            <name>IRemoteSim</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.securecamera</name>
        <interface>
            <name>ISecureCamera</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.sensors</name>
        <interface>
            <name>ISensors</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.snpelaunch</name>
        <interface>
            <name>ISnpelaunch</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.tp</name>
        <interface>
            <name>ITouchscreen</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.wifi</name>
        <interface>
            <name>IHwWifiExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.honor.hardware.wifi.supplicant</name>
        <version>3</version>
        <interface>
            <name>ISupplicantHonor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.nxp.hardware.nfc</name>
        <version>1.0-1</version>
        <version>2.0</version>
        <interface>
            <name>INqNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.nxp.nxpnfc_aidl</name>
        <interface>
            <name>INxpNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.nxp.nxpnfclegacy</name>
        <version>1.0</version>
        <interface>
            <name>INxpNfcLegacy</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.ImsRtpService</name>
        <interface>
            <name>IRTPService</name>
            <instance>ImsRtpService</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.MemHal</name>
        <interface>
            <name>IMemHal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.automotive.qcarcam</name>
        <version>1.0</version>
        <interface>
            <name>IQcarCamera</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.data.dmapconsent</name>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.data.factory</name>
        <version>1.0</version>
        <version>2.0-8</version>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.data.factoryservice</name>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.data.ntn</name>
        <interface>
            <name>IQmsSatelliteService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.data.txpwrservice</name>
        <version>1-7</version>
        <interface>
            <name>ITxPwrService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.diaghal</name>
        <version>1.0</version>
        <interface>
            <name>Idiag</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.diaghal</name>
        <interface>
            <name>Idiag</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.esepowermanager</name>
        <version>1.0-1</version>
        <interface>
            <name>IEsePowerManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.gnss</name>
        <version>1.0-2</version>
        <version>2.0-1</version>
        <version>3.0</version>
        <version>4.0-3</version>
        <interface>
            <name>ILocHidlGnss</name>
            <instance>gnss_vendor</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.gnss</name>
        <version>1-7</version>
        <interface>
            <name>ILocAidlGnss</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.AGMIPC</name>
        <version>1.0</version>
        <interface>
            <name>IAGM</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.ListenSoundModel</name>
        <version>1.0</version>
        <interface>
            <name>IListenSoundModel</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.ListenSoundModelAidl</name>
        <interface>
            <name>IListenSoundModel</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.agm</name>
        <interface>
            <name>IAGM</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.alarm</name>
        <version>1.0</version>
        <interface>
            <name>IAlarm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.alarm</name>
        <interface>
            <name>IAlarm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.bluetooth.xpanprovider</name>
        <interface>
            <name>IXpanProvider</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.bluetooth_audio</name>
        <version>2.0-1</version>
        <interface>
            <name>IBluetoothAudioProvidersFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.bluetooth_sar</name>
        <version>1.0-1</version>
        <interface>
            <name>IBluetoothSar</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.bluetooth_sar</name>
        <interface>
            <name>IBluetoothSar</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.btconfigstore</name>
        <version>1.0</version>
        <version>2.0</version>
        <interface>
            <name>IBTConfigStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.bttpi</name>
        <version>1-3</version>
        <interface>
            <name>IBtTpi</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.c2pa</name>
        <interface>
            <name>IC2PA</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cacert</name>
        <version>1.0</version>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.cacertaidlservice</name>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.camera.aon</name>
        <version>1.0-4</version>
        <interface>
            <name>IAONService</name>
            <instance>aoncameraservice</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.camera.aon</name>
        <version>1-2</version>
        <interface>
            <name>IAONService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.camera.offlinecamera</name>
        <interface>
            <name>IOfflineCameraService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.camera.postproc</name>
        <version>1.0</version>
        <interface>
            <name>IPostProcService</name>
            <instance>camerapostprocservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.capabilityconfigstore</name>
        <version>1.0</version>
        <interface>
            <name>ICapabilityConfigStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.capabilityconfigstore</name>
        <interface>
            <name>ICapabilityConfigStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cryptfshw</name>
        <version>1.0</version>
        <interface>
            <name>ICryptfsHw</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cvp</name>
        <version>1.0</version>
        <interface>
            <name>ICvp</name>
            <instance>cvphalservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.connection</name>
        <version>1.0-1</version>
        <interface>
            <name>IDataConnection</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.data.connectionaidl</name>
        <interface>
            <name>IDataConnection</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.data.connectionfactory</name>
        <interface>
            <name>IFactory</name>
            <instance>slot0</instance>
            <instance>slot1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.iwlan</name>
        <version>1.0-1</version>
        <interface>
            <name>IIWlan</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.data.iwlandata</name>
        <version>1-2</version>
        <interface>
            <name>IIWlan</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.latency</name>
        <version>1.0</version>
        <interface>
            <name>ILinkLatency</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.debugutils</name>
        <version>1.0</version>
        <interface>
            <name>IDebugUtils</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.debugutils</name>
        <interface>
            <name>IDebugUtils</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.display.aiqe</name>
        <version>1-2</version>
        <interface>
            <name>IDisplayAiqe</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.allocator</name>
        <version>1.0</version>
        <version>3.0</version>
        <version>4.0</version>
        <interface>
            <name>IQtiAllocator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.display.color</name>
        <interface>
            <name>IDisplayColor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.composer</name>
        <version>2.0-1</version>
        <version>3.0</version>
        <version>3.1</version>
        <version>3.2</version>
        <interface>
            <name>IQtiComposer</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.display.composer3</name>
        <interface>
            <name>IQtiComposer3Client</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.display.config</name>
        <version>1-12</version>
        <interface>
            <name>IDisplayConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.demura</name>
        <version>1.0</version>
        <version>2.0</version>
        <interface>
            <name>IDemuraFileFinder</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.display.demura</name>
        <interface>
            <name>IDemuraFileFinder</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.mapper</name>
        <version>2.0</version>
        <version>3.0</version>
        <version>4.0</version>
        <interface>
            <name>IQtiMapper</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.display.postproc</name>
        <interface>
            <name>IDisplayPostproc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.dpmaidlservice</name>
        <interface>
            <name>IDpmService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.dpmservice</name>
        <version>1.0-1</version>
        <interface>
            <name>IDpmService</name>
            <instance>DpmService</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.dsp</name>
        <interface>
            <name>IDspService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.dsp</name>
        <version>1.0</version>
        <interface>
            <name>IDspService</name>
            <instance>dspservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.eid</name>
        <version>1.0</version>
        <interface>
            <name>IEid</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.embmssl</name>
        <version>1.0-1</version>
        <interface>
            <name>IEmbms</name>
            <instance>embmsslServer0</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.embmssl</name>
        <version>1-2</version>
        <interface>
            <name>IEmbms</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.factory</name>
        <version>1.0-1</version>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.factory</name>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fingerprint</name>
        <version>1.0</version>
        <interface>
            <name>IQtiExtendedFingerprint</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.fingerprint</name>
        <interface>
            <name>IQfpExtendedFingerprint</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fm</name>
        <version>1.0</version>
        <interface>
            <name>IFmHci</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.fm</name>
        <interface>
            <name>IFmHci</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fstman</name>
        <version>1.0</version>
        <interface>
            <name>IFstManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.hexlp</name>
        <interface>
            <name>IHexlpService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.improvetouch.touchcompanion</name>
        <version>1.0</version>
        <interface>
            <name>ITouchCompanion</name>
            <instance>TouchCompanionService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.iop</name>
        <version>2.0</version>
        <interface>
            <name>IIop</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.limits</name>
        <version>1.0-2</version>
        <interface>
            <name>ILimits</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.minkipcbinder</name>
        <interface>
            <name>IMinkServer</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.mwqemadapter</name>
        <version>1.0</version>
        <interface>
            <name>IMwqemAdapter</name>
            <instance>MwqemAdapter</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.mwqemadapteraidlservice</name>
        <interface>
            <name>IMwqemAdapter</name>
            <instance>MwqemAdapter</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.pal</name>
        <version>1.0</version>
        <interface>
            <name>IPAL</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.pal</name>
        <interface>
            <name>IPAL</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.paleventnotifier</name>
        <interface>
            <name>IPALEventNotifier</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.perf</name>
        <version>2.0-3</version>
        <interface>
            <name>IPerf</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.perf2</name>
        <interface>
            <name>IPerf</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.power.powermodule</name>
        <version>1.0</version>
        <interface>
            <name>IPowerModule</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.power.powermodule</name>
        <interface>
            <name>IPowerModule</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qasr</name>
        <interface>
            <name>IQasr</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qccvndhal</name>
        <version>1.0</version>
        <interface>
            <name>IQccvndhal</name>
            <instance>qccvndhal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qconfig</name>
        <version>1.0</version>
        <interface>
            <name>IQConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qconfig</name>
        <interface>
            <name>IQConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qdutils_disp</name>
        <version>1.0</version>
        <interface>
            <name>IQdutilsDisp</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qseecom</name>
        <version>1.0</version>
        <interface>
            <name>IQSEECom</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qseecom</name>
        <interface>
            <name>IQSEECom</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qspa</name>
        <interface>
            <name>IQspa</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qteeconnector</name>
        <version>1.0</version>
        <interface>
            <name>IAppConnector</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IGPAppConnector</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qteeconnector</name>
        <interface>
            <name>IAppConnector</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IGPAppConnector</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <version>1-2</version>
        <interface>
            <name>IQXRAudioService</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IQXRCamService</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IQXRCommService</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IQXRCoreService</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IQXRModService</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IQXRSplitService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.am</name>
        <version>1.0</version>
        <interface>
            <name>IQcRilAudio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.am</name>
        <interface>
            <name>IQcRilAudio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.atcmdfwd</name>
        <interface>
            <name>IAtCmdFwd</name>
            <instance>AtCmdFwdAidl</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.atfwd</name>
        <interface>
            <name>IAtFwd</name>
            <instance>AtFwdAidl</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.ims</name>
        <version>1.0-9</version>
        <interface>
            <name>IImsRadio</name>
            <instance>imsradio0</instance>
            <instance>imsradio1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.ims</name>
        <version>1-16</version>
        <interface>
            <name>IImsRadio</name>
            <instance>imsradio0</instance>
            <instance>imsradio1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.internal.deviceinfo</name>
        <version>1.0</version>
        <interface>
            <name>IDeviceInfo</name>
            <instance>deviceinfo</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.internal.deviceinfo</name>
        <interface>
            <name>IDeviceInfo</name>
            <instance>deviceinfo</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.lpa</name>
        <version>1.0-3</version>
        <interface>
            <name>IUimLpa</name>
            <instance>UimLpa0</instance>
            <instance>UimLpa1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.lpa</name>
        <interface>
            <name>IUimLpa</name>
            <instance>UimLpa0</instance>
            <instance>UimLpa1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qcrilhook</name>
        <version>1.0</version>
        <interface>
            <name>IQtiOemHook</name>
            <instance>oemhook0</instance>
            <instance>oemhook1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.qcrilhook</name>
        <interface>
            <name>IQtiOemHook</name>
            <instance>oemhook0</instance>
            <instance>oemhook1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qtiradio</name>
        <version>1.0</version>
        <version>2.0-7</version>
        <interface>
            <name>IQtiRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.qtiradio</name>
        <version>1-14</version>
        <interface>
            <name>IQtiRadioStable</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.qtiradioconfig</name>
        <version>1-6</version>
        <interface>
            <name>IQtiRadioConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim</name>
        <version>1.1-2</version>
        <interface>
            <name>IUim</name>
            <instance>Uim0</instance>
            <instance>Uim1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.uim</name>
        <interface>
            <name>IUim</name>
            <instance>Uim0</instance>
            <instance>Uim1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_client</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceClient</name>
            <instance>uimRemoteClient0</instance>
            <instance>uimRemoteClient1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_client</name>
        <interface>
            <name>IUimRemoteServiceClient</name>
            <instance>uimRemoteClient0</instance>
            <instance>uimRemoteClient1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_server</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceServer</name>
            <instance>uimRemoteServer0</instance>
            <instance>uimRemoteServer1</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_server</name>
        <interface>
            <name>IUimRemoteServiceServer</name>
            <instance>uimRemoteServer0</instance>
            <instance>uimRemoteServer1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.scve.objecttracker</name>
        <version>1.0</version>
        <interface>
            <name>IObjectTracker</name>
            <instance>objectTracker</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.scve.panorama</name>
        <version>1.0</version>
        <interface>
            <name>IPanoramaStitching</name>
            <instance>panoStitching</instance>
        </interface>
        <interface>
            <name>IPanoramaTracking</name>
            <instance>panoTracking</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.seccam</name>
        <version>1.0</version>
        <interface>
            <name>ISecCam</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.secureprocessor.device</name>
        <version>1.0</version>
        <interface>
            <name>ISecureProcessor</name>
            <instance>qti-tee</instance>
            <instance>qti-tvm</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.secureprocessor.device</name>
        <interface>
            <name>ISecureProcessor</name>
            <instance>qti-tee</instance>
            <instance>qti-tvm</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.sensorscalibrate</name>
        <version>1.0</version>
        <interface>
            <name>ISensorsCalibrate</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.sensorscalibrate</name>
        <interface>
            <name>ISensorsCalibrate</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.servicetracker</name>
        <version>1.0-2</version>
        <interface>
            <name>IServicetracker</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.servicetrackeraidl</name>
        <interface>
            <name>IServicetracker</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.slmadapter</name>
        <version>1.0</version>
        <interface>
            <name>ISlmAdapter</name>
            <instance>SlmAdapter</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.soter</name>
        <version>1.0</version>
        <interface>
            <name>ISoter</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.soter</name>
        <interface>
            <name>ISoter</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.spu</name>
        <version>1-2</version>
        <interface>
            <name>ISPUManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.sxrhal</name>
        <version>1.0</version>
        <interface>
            <name>ISxrCrypto</name>
            <instance>sxrhalservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.systemhelper</name>
        <version>1.0</version>
        <interface>
            <name>ISystemEvent</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>ISystemResource</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.systemhelperaidl</name>
        <interface>
            <name>ISystemEvent</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>ISystemResource</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.trustedui</name>
        <version>1.0-2</version>
        <interface>
            <name>ITrustedInput</name>
            <instance>default</instance>
            <instance>qtee-vm</instance>
        </interface>
        <interface>
            <name>ITrustedUI</name>
            <instance>default</instance>
            <instance>qtee-vm</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.trustedui</name>
        <interface>
            <name>ITrustedInput</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>ITrustedUI</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.tui_comm</name>
        <version>1.0</version>
        <interface>
            <name>ITuiComm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.vpp</name>
        <version>1.1-3</version>
        <version>2.0</version>
        <interface>
            <name>IHidlVppService</name>
            <instance>vppService</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.vpp</name>
        <interface>
            <name>IVppService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.hostapd</name>
        <version>1.0-3</version>
        <interface>
            <name>IHostapdVendor</name>
            <instance>default</instance>
            <instance>wigighostapd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.supplicant</name>
        <version>2.0-3</version>
        <interface>
            <name>ISupplicantVendor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.wifi.supplicant</name>
        <interface>
            <name>ISupplicantVendor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wificfr</name>
        <version>1.0</version>
        <interface>
            <name>IWificfr</name>
            <instance>wificfr</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.wifi.wificfr</name>
        <interface>
            <name>IWificfr</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifilearner</name>
        <version>1.0</version>
        <interface>
            <name>IWifiStats</name>
            <instance>wifiStats</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifilearner</name>
        <interface>
            <name>IWifiStats</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifimyftm</name>
        <version>1.0</version>
        <interface>
            <name>IWifiMyFtm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifimyftm</name>
        <interface>
            <name>IWifiMyFtm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifidisplaysession</name>
        <version>1.0</version>
        <interface>
            <name>IWifiDisplaySession</name>
            <instance>wifidisplaysession</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionAudioTrack</name>
            <instance>wifidisplaysessionaudiotrack</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionImageTrack</name>
            <instance>wifidisplaysessionimagetrack</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionVideoTrack</name>
            <instance>wifidisplaysessionvideotrack</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.wifidisplaysession_aidl</name>
        <interface>
            <name>IWifiDisplaySession</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionAudioTrack</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionImageTrack</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionVideoTrack</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wigig.netperftuner</name>
        <version>1.0</version>
        <interface>
            <name>INetPerfTuner</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wigig.supptunnel</name>
        <version>1.0</version>
        <interface>
            <name>ISuppTunnelProvider</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wipower</name>
        <version>1.0</version>
        <interface>
            <name>IWipower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.ims.callinfo</name>
        <version>1.0</version>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.ims.datachannelservice</name>
        <version>1-2</version>
        <interface>
            <name>IDataChannelService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.ims.factory</name>
        <version>1.0-1</version>
        <version>2.0-2</version>
        <interface>
            <name>IImsFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.ims.factoryaidlservice</name>
        <interface>
            <name>IImsFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.ims.imscmaidlservice</name>
        <interface>
            <name>IImsCmService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.ims.uceaidlservice</name>
        <interface>
            <name>IUceService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.imsrtpservice</name>
        <version>3.0</version>
        <version>3.1</version>
        <interface>
            <name>IRTPService</name>
            <instance>imsrtpservice</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.memory.pasrmanager</name>
        <interface>
            <name>IPasrManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.memory.pasrmanager</name>
        <version>1.0-1</version>
        <interface>
            <name>IPasrManager</name>
            <instance>pasrhal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.mstatservice</name>
        <version>1.0</version>
        <interface>
            <name>IMStatService</name>
            <instance>mstatservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.power.pasrmanager</name>
        <version>1.0</version>
        <interface>
            <name>IPasrManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qccsyshal_aidl</name>
        <interface>
            <name>IQccsyshal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qccvndhal_aidl</name>
        <interface>
            <name>IQccvndhal</name>
            <instance>qccvndhal</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qegahal</name>
        <interface>
            <name>IQegahal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qepi</name>
        <interface>
            <name>IQEPI</name>
            <instance>qepi</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.qesdhal</name>
        <version>1.0-4</version>
        <interface>
            <name>IQesdhal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qesdhalaidl</name>
        <version>1-2</version>
        <interface>
            <name>IQesdhal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.qspmhal</name>
        <version>1.0</version>
        <interface>
            <name>IQspmhal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qspmhal</name>
        <interface>
            <name>IQspmhal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qvirt</name>
        <version>1-2</version>
        <interface>
            <name>IVirtualizationService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.qvirtvendor</name>
        <interface>
            <name>IVendorVM</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.snapdragonServices</name>
        <interface>
            <name>ISnapdragonServices</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.snapdragonServices.qape</name>
        <interface>
            <name>IQape</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.snapdragonServices.sanityService</name>
        <interface>
            <name>ISanityService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.snapdragonServices.sanityService</name>
        <interface>
            <name>ISanityADK</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.spu</name>
        <version>1.0-1</version>
        <version>2.0</version>
        <interface>
            <name>ISPUManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.syshealthmon</name>
        <interface>
            <name>ISysHealthMon</name>
            <instance>default</instance>
        </interface>
    </hal>
    <sepolicy>
        <kernel-sepolicy-version>30</kernel-sepolicy-version>
        <sepolicy-version>29.0</sepolicy-version>
        <sepolicy-version>30.0</sepolicy-version>
        <sepolicy-version>31.0</sepolicy-version>
        <sepolicy-version>32.0</sepolicy-version>
        <sepolicy-version>33.0</sepolicy-version>
        <sepolicy-version>34.0</sepolicy-version>
        <sepolicy-version>202404</sepolicy-version>
    </sepolicy>
    <avb>
        <vbmeta-version>1.0</vbmeta-version>
    </avb>
</compatibility-matrix>
